/* *****************************************************************************
 * File:      imsc.h
 * Date:      23 Apr 2024
 * Author:    Andrew Levido
 *
 * Copyright 2024 Imbrius Pty Ltd - All Rights Reserved
 *
 ******************************************************************************/
#ifndef _imsc_H
#define _imsc_H

#ifdef __cplusplus
extern "C" {
#endif

/* Description -----------------------------------------------------------------
*  Implements the main state machine for the IMSC using the state machine 
*  framework in state_machine.c.
*
*/

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include <stdbool.h>

/* Defines -------------------------------------------------------------------*/

/* Typedefs & Enumerations ---------------------------------------------------*/

/* Public Functions Declarations ---------------------------------------------*/

/* Start IMSC state machine 
 *
 * This function never returns 
 */
void imsc_start(void);

/* Task Function -------------------------------------------------------------*/

/* Interrupt Service Routine Declarations ------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif

/* End imsc */